<!--1. only add button shown
    2. add button -> pre-filled custom maps fields are shown (default job) and added to prophaneJob.param
    3. changes in fields (input file name empty!) changed in prohane job params
    4. add file to files to upload  -->
<div *ngIf="prophaneJobState.getCustomTasks().length === 0">
  No custom map annotation task defined.
  <mat-divider class="mb-3"> </mat-divider>
</div>


<!--  already added/defined custom Maps -->
<ng-container *ngFor="let custom_task of this.prophaneJobState.getCustomTasks(); let customIndex = index">
    <!--  task Label-->
    <div class="card-body">
      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text rki-blue_button">Task Label</span>
        </div>
        <input
          type="text"
          class="form-control"
          [ngClass]="{'is-invalid': !prophaneJobState.isFormInputValid(
                      'Custom_map_task_' + customIndex, custom_task, 'tasklabel', true,
                      prophaneJobState.getCustomTasks()
                      )
                  }"
          [(ngModel)]="custom_task.tasklabel">
        <div class="input-group-append">
          <button
            style="border-bottom-right-radius: 0.25rem; border-top-right-radius: 0.25rem "
            class="btn btn-outline-secondary w-sbtn" type="button" (click)='removeCustomTask(custom_task, customIndex)'>
            —
          </button>
        </div>
      </div>

      <!-- not working, always first custom_task with customIndex 0 changed in onMapChange
      <app-file-input
        (fileSelected)="onMapChange(custom_task, customIndex, $event)"
        [selectedFile]="prophaneJobState.customMapFiles[customIndex]"
        [labels]="{inputGroupLabel: 'Custom Map File', inputLabel: 'Choose file (.tsv, .csv, .txt)'}"
        [inputType]="'.tsv, .csv, .txt'"
      >
      </app-file-input>
      -->

      <!-- Reference Database /task map file to upload  -->
      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text">Custom Map File</span>
        </div>
        <div class="custom-file input-group-append" style="flex: 1; overflow:hidden">
          <input type="file" 
                accept='.tsv, .csv, .txt'
                id='{{"custom_map_" + customIndex}}'
                #customfile
                (change)="onMapChange(custom_task, customIndex, customfile.files)"
                class="custom-file-input">
          <label *ngIf="!prophaneJobState.customMapFiles[customIndex]" 
                class="custom-file-label"
                for='{{"custom_map_" + customIndex}}'>
                Choose custom map file (.tsv, .csv, .txt)</label>
          <label *ngIf="prophaneJobState.customMapFiles[customIndex]" 
                class="custom-file-label"
                for='{{"custom_map_" + customIndex}}'>
                {{prophaneJobState.customMapFiles[customIndex].name}}</label>
        </div>
      </div>

      <!--  scope-->
      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text">Task Type</span>
        </div>        
        <mat-select class="custom-select input-group-append"
                    style="flex: 1; overflow:hidden"
                    [(value)]="custom_task.scope"
                    [compareWith]="prophaneJobState.compareByID">
          <mat-option *ngFor="let scope of prophaneJobState.optionCustomMaps.scope" [value]="scope">
            {{scope}}
          </mat-option>
        </mat-select>
      </div>

      <!-- Algorithm, always the same-->
      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text">Search Algorithm</span>
        </div>
        <mat-select class="custom-select input-group-append"
                    style="flex: 1; overflow:hidden"
                    [(value)]="custom_task.algorithm">
          <ng-container *ngFor="let algo of prophaneJobState.optionCustomMaps.algorithm">
            <mat-option [value]="algo">
              {{ algo }}
            </mat-option>
          </ng-container>
        </mat-select>
      </div>
    </div>
  </ng-container>

  <!-- Add new Custom Map Task -->
  <button type="button" class="btn btn-primary float-right rki-blue_button" (click)='addCustomMapTask()'>
    Add Custom Map Task
  </button>

